const
    Glob = require("glob");

class ApiHandler{

    constructor(options) {
        this.services = {};
        let classes = Glob.sync(__dirname + "/class/**/*.js");
        for (let i = 0; i < classes.length; i++) {
            let cls = require(classes[i]);
            let service = cls.service;

            if(typeof service === "object" && service !== null) {
                if(this.services[service.url]) {
                    throw new Exception(0,"DUPLICATE SERVICE "+ service.url )
                }

                this.services[service.url] = {
                    class: cls,
                    method : service.method
                };
            }

        }
    }

    getClass(url){

        let className;
        if(this.services[url]) {
            className = this.services[url].class;
        } else {
            className = this.services["NOT_FOUND"].class;
        }

        return className;
    }

    getPrivacy(url,method) {
        let privacy;

        if(this.services[url]) {
            privacy = this.services[url].method[method].privacy;
        }
        return privacy;
    }
}

module.exports = ApiHandler;